models/Escritores.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "escritores".
 *
 * @property int $id
 * @property string|null $nombre
 * @property string|null $f_nacimiento
 * @property string|null $lugar_nacimiento
 * @property string|null $biografia
 *
 * @property Libros[] $codLibros
 * @property Escribir[] $escribirs
 */
class Escritores extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'escritores';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['f_nacimiento'], 'safe', ],
            [['nombre', 'lugar_nacimiento'], 'string', 'max' => 50],
            ['lugar_nacimiento', 'match', 'pattern' => "/^([a-z\sáéíóúñÁÉÍÓÚüÜàèìòùÀÈÌÒÙÑ.]+)$/i"],
            ['nombre', 'match', 'pattern' => "/^([a-z\sáéíóúñÁÉÍÓÚüÜàèìòùÀÈÌÒÙÑ.]+)$/i"],
            ['nombre', 'unique', 'targetClass' => 'app\models\Escritores', 'message' => 'Este nombre ya está en uso'],
            [['biografia'], 'string', 'max' => 2500],
        ];
    }

    public function beforeSave($insert)
{
    if ($this->f_nacimiento) {
        $this->f_nacimiento = date("Y-m-d", strtotime($this->f_nacimiento));
    }
    return parent::beforeSave($insert);
}
    
    public function afterFind()
{
    if ($this->f_nacimiento)
    {
        $this->f_nacimiento = date("d-m-Y", strtotime($this->f_nacimiento));
    }
}

public function nombre_existe()
{
    // Verificar si el nombre ya existe en la base de datos
    $existe = Escritores::find()->select('id')->where(['nombre' => $this->nombre])->exists();

    // Si el nombre existe, agregar un error al modelo
    if ($existe) {
        $this->addError('nombre', 'El autor ya existe en la base de datos.');
    }
}
    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'nombre' => 'Nombre',
            'f_nacimiento' => 'Fecha de nacimiento',
            'lugar_nacimiento' => 'Nacionalidad',
            'biografia' => 'Biografia',
        ];
    }

    /**
     * Gets query for [[CodLibros]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getCodLibros()
    {
        return $this->hasMany(Libros::class, ['id' => 'cod_libro'])->viaTable('escribir', ['cod_escritor' => 'id']);
    }

    /**
     * Gets query for [[Escribirs]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getEscribirs()
    {
        return $this->hasMany(Escribir::class, ['cod_escritor' => 'id']);
    }
    
    
    
    public static function getEscritoresOptions()
{
    $escritores = self::find()->orderBy('nombre')->all();
    return \yii\helpers\ArrayHelper::map($escritores, 'id', 'nombre');
}
}

controllers/EscritoresController.php
<?php

namespace app\controllers;

use app\models\Escritores;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EscritoresController implements the CRUD actions for Escritores model.
 */
class EscritoresController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Escritores models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Escritores::find(),
            
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'nombre' => SORT_ASC,
                ]
            ],
            
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Escritores model.
     * @param int $id ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Escritores model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
{
    $model = new Escritores();

    if ($this->request->isPost) {
        if ($model->load($this->request->post()) && $model->validate() && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }
    } else {
        $model->loadDefaultValues();
    }

    return $this->render('create', [
        'model' => $model,
    ]);
}

    /**
     * Updates an existing Escritores model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $id ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Escritores model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $id ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Escritores model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $id ID
     * @return Escritores the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Escritores::findOne(['id' => $id])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

views/escritores/_autor.php
<?php
use yii\helpers\ArrayHelper;
use yii\helpers\Html;

?>


<div class="col-sm-12">
            <div class="card autores">
                
             <?= Html::img('@web/img/autor/'.$model->nombre.'.jpg', ['alt'=>'Autor','class'=>'escritoresImg']) ?>
                
                <?= Html::a($model ->nombre,['escritores/view', 'id'=>$model -> id ], ['class' => 'h6'])?>
             
            </div>
        </div>

views/escritores/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\widgets\ActiveField;
use \yii\widgets\InputWidget;
use kartik\date\DatePicker;
use kartik\editors\Summernote;

/** @var yii\web\View $this */
/** @var app\models\Escritores $model */
/** @var yii\widgets\ActiveForm $form */
?>

<div class="escritores-form">

    <?php $form = ActiveForm::begin();
?>
<div class="form-group">
    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true, 'placeholder' => 'Escribe el nombre']) ?>
</div>

<div class="form-group">
    <?= $form->field($model, 'f_nacimiento',  [
   'labelOptions' => ['label' => 'Fecha de nacimiento']]
    //  'addon'=>['prepend'=>['content'=>'<i class="fas fa-calendar-alt"></i>']],
      
    )->widget(DatePicker::classname(), [
  'name'=>'f_nacimiento',
 'options' => ['placeholder' => 'Seleccione una fecha'],
    'pluginOptions' => [
        'format' => 'yyyy-m-dd',
        'todayHighlight' => true,
        'autoclose'=>true,
        'convertFormat' => true, // convierte automáticamente el formato devuelto al formato utilizado para mostrar la fecha
    ]
    
]) //. $addon;
       
?>
</div>

<div class="form-group">
    <?= $form->field($model, 'lugar_nacimiento')->textInput(['maxlength' => true,'placeholder' => 'Escribe la nacionalidad']) ?>
</div>

<div class="form-group">
    <?= $form->field($model, 'biografia')->widget(Summernote::class, [
 'useKrajeePresets' => true,
        'pluginOptions'=>[
    'height' => 200,
    'dialogsFade' => true,
    'toolbar' => [
        ['style1', ['style']],
        ['style2', ['bold', 'italic', 'underline', 'strikethrough', 'superscript', 'subscript']],
        ['font', ['fontname', 'fontsize', 'color', 'clear']],
        ['para', ['ul', 'ol', 'paragraph', 'height']],
        ['insert', ['link', 'picture', 'video', 'table', 'hr']],
    ],
    'fontSizes' => ['8', '9', '10', '11', '12', '13', '14', '16', '18', '20', '24', '36', '48'],
    'codemirror' => [
      //  'theme' => Codemirror::DEFAULT_THEME,
        'lineNumbers' => true,
        'styleActiveLine' => true,
        'matchBrackets' => true,
        'smartIndent' => true,
        'enablePrettyFormat'=>false,
        'autoFormatCode'=>false,
        
    ],
               'placeholder' => 'Ingrese la biografía',
]

]);?>
</div>

   <div class="form-group">
         <?= Html::resetButton('Borrar', ['class' => 'btn btn-secondary btn-default']) ?>
        <?= Html::submitButton('Guardar', ['class' => 'btn btn-success']) ?>
    </div>

 
    <?php ActiveForm::end(); ?>

</div>

views/escritores/create.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Escritores $model */

$this->title = 'Create Escritores';
$this->params['breadcrumbs'][] = ['label' => 'Escritores', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="escritores-create">

    <h2><?= Html::encode($this->title) ?></h2>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/escritores/index.php
<?php

use app\models\Escritores;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use  yii\widgets\ListView;

/** @var yii\web\View $this */
/** @var yii\data\ActiveDataProvider $dataProvider */

$this->title = 'Escritores';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="escritores-index">

    <h2><?= Html::encode($this->title) ?></h2>

    <p>
        <?= Html::a('Nuevo Escritor', ['create'], ['class' => 'btn btn-success']) ?>
    </p>

     

            <?=   ListView::widget([
                  'dataProvider' => $dataProvider,
                 'itemView' => '_autor',
                  'layout'=>"\n{items}",
      
              ]);
            ?>
   
     

  


</div>

views/escritores/update.php
<?php

use yii\helpers\Html;

/** @var yii\web\View $this */
/** @var app\models\Escritores $model */

$this->title = 'Actualizar Escritores: ' . $model->nombre;
$this->params['breadcrumbs'][] = ['label' => 'Escritores', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->nombre, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Actualizar';
?>
<div class="escritores-update">

    <h2><?= Html::encode($this->title) ?></h2>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/escritores/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/** @var yii\web\View $this */
/** @var app\models\Escritores $model */

$this->title = $model->nombre;
$this->params['breadcrumbs'][] = ['label' => 'Escritores', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="escritores-view">

    <h2><?= Html::encode($this->title) ?></h2>

    <p>
        <?= Html::a('Actualizar', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Borrar', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => '¿Está seguro que quiere borrar este elemento?',
                'method' => 'post',
            ],
          

        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'nombre',
            'f_nacimiento',
            'lugar_nacimiento',
                   [
            'attribute' => 'biografia',
            'format' => 'raw',
        ],
            
        ],
    ]) ?>

</div>